//  ** Revision History **
//  15-Jan-1993 (AH) Release 1.0.0.000
//  13-Nov-1992 (AH) Mnenomic Support added
//  13-Nov-1992 (AH) EsCHeck is now Greyed when disabled
//  12-Nov-1992 (AH) Click event now has function as normal CheckBox.(value allright)
//  14-Oct-1992 (AH) ColorBox added
//  03-Jul-1992 (AH) TextBorder problem fixed
//  03-Jul-1992 (AH) About box added
//  24-Jun-1992 (AH) Fire of Click Event added when VALUE changed from Code.
//  24-Jun-1992 (AH) Added VBFire for Click Event
//  22-Jun-1992 (AH) Flyttat till PWB
//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         checkbox.c  (part of EuroTool project)
//   
// PURPOSE:      Make a Ownerdrawn Checkbox
//   
// COMMENTS:     
//   
// HISTORY:      920602AH Prehistory
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "..\eurotool.h"


#include "version.h"
#include <string.h>
#include "escheck.h"

#define  CTL_DATA       // To declare static data in checkbox.h
#include "checkbox.h"                                        
#include "vb1.h"		// Support for VB 1.0
#include "vb2.h"		// Support for VB 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;
extern UINT VBVersion;
HANDLE  ghWndCheck;              // handle for hWnd of Control

//---------------------------------------------------------------------------

// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawCheck(HCTL hctl, LPDRAWITEMSTRUCT lpdi);
VOID NEAR RecalcAreaCheck(HCTL hctl, HWND hWnd);

//---------------------------------------------------------------------------
// Event Procedure Parameter Profiles
//---------------------------------------------------------------------------
typedef struct tagPARAMS
{
    HLSTR   ClickString;
    LPVOID  Index;      // Reserve space for index parameter to array ctl
} PARAMS;


//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export CheckCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Check Control Procedure     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

LONG FAR PASCAL _export CheckCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PCHECK      pcheck;

    // Message pre-processing
    switch (msg) 
    {
        case WM_CREATE:
            pcheck = CHECKDEREF(hctl);
            pcheck->Light3DColor = WHITE;
            pcheck->Dark3DColor = DARKGREY;
            pcheck->CheckStyle = CHECKNORMAL;
            pcheck->Align=TEXTTORIGHT;
            pcheck->Font3D=FONT3DNORMAL;
            pcheck->ToggleStatus = FALSE;
            pcheck->ParenthWnd = GetParent(hWnd);
            pcheck->FocusRectOn = TRUE;             // Focus rectangle should be used
            pcheck->MarkFG = BLACK;
            pcheck->MarkBG = WHITE;
            pcheck->TextBorderAlign = HALIGNCENTER;
        
#ifndef RUNTIMEVERSION            
            // set the property text for the About dialog
            SetAboutText(hctl, IPROP_CHECK_ABOUT); 
#endif            
            
            VBSetControlProperty(hctl, IPROP_CHECK_BACKCOLOR, 
                                       CHECK_BACKGROUND_DEFAULT);
        break;

#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_CHECK_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_CHECK_ALIGN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_alignment);
			    		return 0L;                                                        
                
            		case IPROP_CHECK_DARK3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_dark3dcolor);
			    		return 0L;                                            
            
            		case IPROP_CHECK_FOCUSRECTON:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_focusrecton);
			    		return 0L;                                            
            
            		case IPROP_CHECK_FONT3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_font3d);
			    		return 0L;                                       
            
            		case IPROP_CHECK_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                      
            
            		case IPROP_CHECK_LIGHT3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_light3dcolor);
			    		return 0L;                                             
            
                	case IPROP_CHECK_MARKBG:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markbackground);
			    		return 0L;                                            
                     
                	case IPROP_CHECK_MARKFG:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markforeground);
			    		return 0L;                                      
                                                                             
                	case IPROP_CHECK_PICTUREDOWN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedown);
			    		return 0L;
                    
                    case IPROP_CHECK_PICTUREUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_pictureup);
			    		return 0L;
                    
                    case IPROP_CHECK_PICTUREDISABLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedisabled);
			    		return 0L; 
                    
					case IPROP_CHECK_STYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style);
			    		return 0L; 
                    
					case IPROP_CHECK_TOGGLESTATUS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;                                             
                
                	case IPROP_CHECK_TEXTBORDER:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_textborder);
			    		return 0L;                                                    
                
                	case IPROP_CHECK_TEXTBORDERALIGN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_textborderalign);
			    		return 0L;
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escheck);
		    return 0L;
	}
	break;        
                 
        case VBM_INITPROPPOPUP:
        switch (wp) 
        {
	    	case IPROP_CHECK_ABOUT:
                hctlDialog  = hctl;
                ipropDialog = wp;
                return (LONG)HwndInitAboutPopup();
                               
        	case IPROP_CHECK_MARKFG:
        	case IPROP_CHECK_MARKBG:
        	case IPROP_CHECK_DARK3DCOLOR:
        	case IPROP_CHECK_LIGHT3DCOLOR:
            	if (VBVersion < 0x0200) 
            	{
            		hctlDialog  = hctl;
            		ipropDialog = wp;
            		return (LONG)HwndInitColorPopup();
        		}
        }
        break;

#endif        
                
        case WM_ERASEBKGND:
            // Don't bother with erasing the background
            return TRUE;
        
        case VBM_GETDEFSIZE:
            return MAKELONG(CHECKBOX_DEFAULTWIDTH,CHECKBOX_DEFAULTHEIGHT);
        
        case WM_SIZE:
            RecalcAreaCheck(hctl, hWnd); 
            break;
                     
        case WM_SETFONT:
            pcheck = CHECKDEREF(hctl);
            pcheck->hfont = (HFONT)wp;
            
            return(0L);

        case WM_GETFONT:
            pcheck = CHECKDEREF(hctl);
            return (pcheck->hfont);

        case WM_SETTEXT:
        {
            HSZ hsz;

            pcheck = CHECKDEREF(hctl);
            if (pcheck->hszCaption) 
            {
                VBDestroyHsz(pcheck->hszCaption);
            }
            hsz = VBCreateHsz((_segment)hctl, (LPSTR)lp);
            pcheck = CHECKDEREF(hctl);
            pcheck->hszCaption = hsz;
            pcheck->CaptionLen=lstrlen(VBDerefHsz(pcheck->hszCaption));
            RecalcAreaCheck(hctl, hWnd);
            InvalidateRect(hWnd, NULL, TRUE);
            return(0L);
        }
     
        case WM_GETTEXT:
        {    
            LPSTR   lpstr;
            WORD    cch;
            
            pcheck = CHECKDEREF(hctl);
            if (pcheck->hszCaption == NULL) 
            {
                *(LPSTR)lp = 0L;
                wp = 1;
            }
            else 
            {
                lpstr = VBDerefHsz(pcheck->hszCaption);
                cch = lstrlen(lpstr) + 1;
                if (wp > cch)
                    wp = cch;
                _fstrncpy((LPSTR)lp, lpstr, wp);
                ((LPSTR)lp)[wp - 1] = '\0';
            }
        }
        return (LONG)(wp - 1);

        case WM_GETTEXTLENGTH:
            pcheck = CHECKDEREF(hctl);
            if (pcheck->hszCaption == NULL) 
            {
                pcheck->CaptionLen=0;
                return(0L);
            }    
            else
                return (lstrlen(VBDerefHsz(pcheck->hszCaption)));

        case WM_RBUTTONDBLCLK: 
            if (VBGetMode() == MODE_DESIGN) 
            {
            	WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escheck);
            	return OK;
            }
            else
                break;
                    
        case VBM_SETPROPERTY:
            switch (wp) 
            {
                case IPROP_CHECK_CAPTION:
                    // To avoid a Windows problem, make sure text is
                    // under 255 bytes:
                    if (lstrlen((LPSTR)lp) > 255)
                        *((LPSTR)lp + 255) = 0;
                    break;
                    
                case IPROP_CHECK_LIGHT3DCOLOR:
                case IPROP_CHECK_DARK3DCOLOR:
                case IPROP_CHECK_FONT3D:
                case IPROP_CHECK_STYLE:
                case IPROP_CHECK_ALIGN:
                case IPROP_CHECK_MARKFG:
                case IPROP_CHECK_MARKBG:
                case IPROP_CHECK_TEXTBORDER:
                case IPROP_CHECK_TEXTBORDERALIGN:
                case IPROP_CHECK_ENABLED:    
                    RecalcAreaCheck(hctl, hWnd);
                    InvalidateRect(hWnd, NULL, TRUE);
                    break;    
                
                case IPROP_CHECK_TOGGLESTATUS:
                    RecalcAreaCheck(hctl, hWnd);
                    InvalidateRect(hWnd, NULL, TRUE);
                    // Fire Click	
                    VBFireEvent(hctl, EVENT_CHECK_CLICK, NULL);
                    break;    
            }
            break;

        case VBM_CHECKPROPERTY:
            switch (wp)
            {
                case IPROP_CHECK_PICTUREUP:
                case IPROP_CHECK_PICTUREDOWN: 
                {
                    PIC pic;

                    VBGetPic((HPIC)lp, &pic);
                    switch (pic.picType) 
                    {
                        case PICTYPE_NONE:
                        case PICTYPE_BITMAP:
                            InvalidateRect(hWnd, NULL, TRUE);
                            return ERR_None;
                    }
                    return ERR_InvPropVal;
            	}
        	}
        	break;  
            
		case VBM_GETPROPERTY: 
    	{
			if (wp == IPROP_CHECK_HWND) 
			{ 
				ghWndCheck = VBGetControlHwnd(hctl);
				(HWND *)lp = &ghWndCheck; 
				return OK;
			}   
			break; 
    	}                  
		
        case VBN_DRAWITEM:
            DrawCheck(hctl, (LPDRAWITEMSTRUCT)lp);
            return 0;
    
        case VBM_MNEMONIC:  
            lp = MAKELONG(0, BN_CLICKED);
        	// Fall through
        
        case WM_LBUTTONDBLCLK:
            SendMessage(hWnd, VBN_COMMAND, 0, MAKELONG(BN_CLICKED,0)); 
        	VBFireEvent(hctl, EVENT_CHECK_DBLCLICK, NULL);       
        	return OK;
            
        case VBN_COMMAND:    
            switch(HIWORD(lp)) 
            {
                case BN_CLICKED: 
                {
                    pcheck = CHECKDEREF(hctl);
                    pcheck->ToggleStatus = !(pcheck->ToggleStatus);                    
                    InvalidateRect(hWnd, NULL, TRUE);   
                    VBFireEvent(hctl, EVENT_CHECK_CLICK, NULL);
                    return OK;
                }
            }
            break;    
    }

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) 
    {
        case WM_DESTROY:
            VBFreePic(CHECKDEREF(hctl)->hpicDown);
            VBFreePic(CHECKDEREF(hctl)->hpicUp);  
            VBFreePic(CHECKDEREF(hctl)->hpicDisabled);        
            break;
    }
    return lResult;
}


//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawCheck(HCTL hctl, LPDRAWITEMSTRUCT lpdi)       
//
//      PURPOSE:    Draw the Check-button     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawCheck(HCTL hctl, LPDRAWITEMSTRUCT lpdi)
{
    PCHECK  pcheck = CHECKDEREF(hctl);
    LPRECT  prectALL = &pcheck->rectDrawInto;
    LPRECT  prectBox = &pcheck->rectBox;
    LPRECT  prectText = &pcheck->rectText;
    HPIC    hpic;
    PIC     pic;
    HBITMAP hbmp, hbmpOld;
    BITMAP  bmp;
    HDC     hdcMem,hdcClient;
    HBRUSH  hOldBrush,hBrush,hBrushBlack,hBrushWhite,hBrush3DLight,hBrush3DDark;
    HBRUSH  hBrushMark,hBrushMarkBG;
    HPEN    hOldPen,hPenLight,hPenDark,hPenBlack,hPenWhite,hPenGrey;
    HPEN    hPenMark,hPenMarkWide;
    HFONT   hOldFont;
    BOOL	fEnabled;
     
    // check if control is enabled
    VBGetControlProperty(hctl, IPROP_CHECK_ENABLED, (BOOL FAR *)&fEnabled);
             
    switch (lpdi->itemAction) 
    {
        case ODA_DRAWENTIRE:   
            hdcClient = CreateCompatibleDC(lpdi->hDC);
	    	hbmp = CreateCompatibleBitmap(lpdi->hDC,
									prectALL->right-prectALL->left,
									prectALL->bottom-prectALL->top);
	    
	    	if (hbmp == NULL || hdcClient == NULL)
				return;
	    
	    	hbmpOld = SelectObject(hdcClient, hbmp);
            
            // select Control Objects Font                             
			hOldFont = SelectObject(hdcClient, pcheck->hfont);
            
            if (fEnabled)
            	hpic = (pcheck->ToggleStatus) ? pcheck->hpicDown : pcheck->hpicUp;
            else
                hpic = pcheck->hpicDisabled;
            
            VBGetPic(hpic, &pic);
            // Select Control Objects Brush
            hBrush = (HBRUSH)SendMessage(GetParent(lpdi->hwndItem), WM_CTLCOLOR, lpdi->hDC, 
                                         MAKELONG(lpdi->hwndItem,0));
            
            // create pen's                             
            hPenLight  = CreatePen(PS_SOLID,1, RGBCOLOR(pcheck->Light3DColor)); 
            hPenDark   = CreatePen(PS_SOLID,1, RGBCOLOR(pcheck->Dark3DColor));
            hPenWhite  = CreatePen(PS_SOLID,1, WHITE);
            hPenBlack  = CreatePen(PS_SOLID,1, RGBCOLOR(BLACK));
            hPenGrey   = CreatePen(PS_SOLID,1, RGBCOLOR(pcheck->Dark3DColor));
            hPenMark   = CreatePen(PS_SOLID,1, RGBCOLOR(pcheck->MarkFG));
            hPenMarkWide = CreatePen(PS_SOLID,2,RGBCOLOR(pcheck->MarkFG)); 
            
            // create brush's 
            hBrush3DLight = CreateSolidBrush(RGBCOLOR(pcheck->Light3DColor));
            hBrush3DDark  = CreateSolidBrush(RGBCOLOR(pcheck->Dark3DColor));
            hBrushBlack   = CreateSolidBrush(RGBCOLOR(BLACK));
            hBrushWhite   = CreateSolidBrush(WHITE);
            hBrushMark    = CreateSolidBrush(RGBCOLOR(pcheck->MarkFG));
            hBrushMarkBG  = CreateSolidBrush(RGBCOLOR(pcheck->MarkBG));
            
            // Fill backgrund        
            FillRect(hdcClient, prectALL, hBrush); 
            
            // Select new Pen & Brush
            hOldPen = SelectObject(hdcClient, hPenLight);
            hOldBrush = SelectObject(hdcClient, hBrush3DLight);
            
            switch(pcheck->CheckStyle) 
            {
                case CHECKNORMAL:    
                case CHECKCOMPLETE:
                case CHECKCROSSED:
                case CHECKCROSSEDLARGE:
                case CHECKCHECK:
                    SelectObject(hdcClient, hPenDark);
                    SelectObject(hdcClient, hBrushMarkBG);
                    FillRect(hdcClient,&pcheck->rectBox, hBrushMarkBG);
                    MoveTo(hdcClient,prectBox->left, prectBox->bottom);
                    LineTo(hdcClient,prectBox->left, prectBox->top);
                    LineTo(hdcClient,prectBox->right, prectBox->top);
                    SelectObject(hdcClient, hPenLight);
                    LineTo(hdcClient,prectBox->right, prectBox->bottom);
                    LineTo(hdcClient,prectBox->left, prectBox->bottom);
                    SelectObject(hdcClient,hPenBlack);
                    MoveTo(hdcClient, prectBox->left+1, prectBox->bottom-1);
                    LineTo(hdcClient, prectBox->left+1, prectBox->top+1);
                    LineTo(hdcClient, prectBox->right-1, prectBox->top+1);
                    SelectObject(hdcClient, hPenGrey);
                    LineTo(hdcClient, prectBox->right-1, prectBox->bottom-1);
                    LineTo(hdcClient, prectBox->left+2, prectBox->bottom-1);  
                                    
                    if (pcheck->ToggleStatus) 
                    {
                        if (pcheck->CheckStyle==CHECKNORMAL) 
                        {
                            SelectObject(hdcClient, hPenMark);
                            MoveTo(hdcClient, prectBox->left+2, prectBox->top+2);
                            LineTo(hdcClient, prectBox->right-2, prectBox->bottom-2);
                            MoveTo(hdcClient, prectBox->left+2, prectBox->bottom-2);
                            LineTo(hdcClient, prectBox->right-3, prectBox->top+2);
                        }
                        if (pcheck->CheckStyle==CHECKCOMPLETE) 
                        {
                            SelectObject(hdcClient, hBrushMark);
                            Rectangle(hdcClient, prectBox->left+3,
                                                 prectBox->top+3,
                                                 prectBox->right-2,
                                                 prectBox->bottom-2);
                        }
                        if (pcheck->CheckStyle==CHECKCROSSEDLARGE) 
                        {
                            SelectObject(hdcClient, hPenMarkWide);
                            MoveTo(hdcClient, prectBox->left, prectBox->top);
                            LineTo(hdcClient, prectBox->right, prectBox->bottom);
                            MoveTo(hdcClient, prectBox->left, prectBox->bottom);
                            LineTo(hdcClient, prectBox->right, prectBox->top);}
                            
                        if (pcheck->CheckStyle==CHECKCROSSED) 
                        {
                            SelectObject(hdcClient, hPenMarkWide);
                            MoveTo(hdcClient, prectBox->left+3, prectBox->top+3);
                            LineTo(hdcClient, prectBox->right-3, prectBox->bottom-3);
                            MoveTo(hdcClient, prectBox->left+3, prectBox->bottom-3);
                            LineTo(hdcClient, prectBox->right-3, prectBox->top+3);
                        } 
                        if (pcheck->CheckStyle==CHECKCHECK) 
                        {
                            SelectObject(hdcClient, hPenMarkWide);
                            MoveTo(hdcClient, prectBox->left+3, prectBox->top+1);
                            LineTo(hdcClient, prectBox->left+6, prectBox->top+9);
                            LineTo(hdcClient, prectBox->right-2, prectBox->top-3);
                        }
                    }                    
                break;              
                    
                case CHECKPICTURE:
                    // Only bitmap is accepted
                    if (pic.picType==PICTYPE_BITMAP) 
                    {
                        GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
                        hdcMem = CreateCompatibleDC(hdcClient);
                        SelectObject(hdcMem, pic.picData.bmp.hbitmap);
                        StretchBlt(hdcClient, prectBox->left,  prectBox->top,
                                    (prectBox->right - prectBox->left),
                                    (prectBox->bottom - prectBox->top),
                                    hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
                                    SRCCOPY);
                    	DeleteDC(hdcMem);
                    }
                    break; 
                    
                 case CHECKPICTURELARGE:
                    // Only bitmap is accepted
                    if (pic.picType==PICTYPE_BITMAP) 
                    {
                        GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
                        hdcMem = CreateCompatibleDC(hdcClient);
                        SelectObject(hdcMem, pic.picData.bmp.hbitmap);
                        StretchBlt(hdcClient, 
                                    (pcheck->Align==TEXTTORIGHT) ? prectALL->left : prectText->right+2,  
                                    (pcheck->Align==TEXTTORIGHT) ? prectALL->top  : prectText->top,
                                    ((pcheck->Align==TEXTTORIGHT) ? (prectText->left-prectALL->left-2) : 
                                                                    (prectALL->right-prectText->right-2)),
                                    (prectALL->bottom - prectALL->top),
                                    hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
                                    SRCCOPY);
                    	DeleteDC(hdcMem);
                    }
                    break;                         
            }                        
            
            // Restore old objects
            //   Font restored after Focus-work
            SelectObject(hdcClient, hOldBrush); 
            SelectObject(hdcClient, hOldPen);
            
            // draw text
            if (pcheck->CaptionLen != 0) 
            {
                SelectObject(hdcClient, hBrush); 
                if (pcheck->TextBorder == BORDERNONE) 
                {    
                    DrawFont3D(hdcClient, VBDerefHsz(pcheck->hszCaption), &CHECKDEREF(hctl)->rectText,
                    	(((CHECKDEREF(hctl)->Align == TEXTTORIGHT) ? DT_LEFT : DT_RIGHT) |
                    	DT_VCENTER | DT_SINGLELINE), CHECKDEREF(hctl)->Font3D, TRANSPARENT, 
                		fEnabled ? GetTextColor(lpdi->hDC) : DARKGREY);
                }
                else 
                {
                    int halign;
                    
                    switch(pcheck->TextBorderAlign) 
                    {
                        case HALIGNLEFT:
                            halign = DT_LEFT;
                            break;
                        case HALIGNCENTER:
                            halign = DT_CENTER;
                            break;
                        case HALIGNRIGHT:
                            halign = DT_RIGHT;
                            break;
                    }
                    DrawFont3D(hdcClient, VBDerefHsz(pcheck->hszCaption), &CHECKDEREF(hctl)->rectText,
                                 (halign | DT_VCENTER | DT_SINGLELINE), CHECKDEREF(hctl)->Font3D,
                                 TRANSPARENT, fEnabled ? GetTextColor(lpdi->hDC) : DARKGREY);              
                }    
            }

            // frame text
            if (CHECKDEREF(hctl)->TextBorder != BORDERNONE) 
            {
                RECT    rect, rectupper, rectlower;
                
                pcheck = CHECKDEREF(hctl);
                
                // calculate frame rectangle
                rect.left   = (pcheck->Align == TEXTTOLEFT) ? pcheck->rectText.left-2: 
                                                              pcheck->rectText.left-2;
                rect.top    = pcheck->rectText.top+1;
                rect.right  = (pcheck->Align == TEXTTOLEFT) ? pcheck->rectText.right+3 : 
                                                              pcheck->rectText.right+1;
                rect.bottom = pcheck->rectText.bottom-2;
                
                // calculate upper rectangle
                rectupper.left   = rect.left-1;
                rectupper.top    = rect.top-1;
                rectupper.right  = rect.right-1;
                rectupper.bottom = rect.bottom-1;
                
                // calculate lower rectangle
                rectlower.left   = rect.left+1;
                rectlower.top    = rect.top+1;
                rectlower.right  = rect.right+1;
                rectlower.bottom = rect.bottom+1;
                
                switch(CHECKDEREF(hctl)->TextBorder) 
                {
                    case BORDERFRAME:
                        FrameRect(hdcClient, &rect, hBrushBlack);
                        break;
                    
                    case BORDER3DCARVED:
                        FrameRect(hdcClient, &rectupper, hBrush3DDark);
                        FrameRect(hdcClient, &rectlower, hBrush3DLight);
                        FrameRect(hdcClient, &rect, hBrush);                        
                        break;
                    
                    case BORDER3DRAISED:
                        FrameRect(hdcClient, &rectupper, hBrush3DLight);
                        FrameRect(hdcClient, &rectlower, hBrush3DDark);
                        FrameRect(hdcClient, &rect, hBrush);
                        break;        
                }
            }
            
            // Restore old objects
	    	//   Font restored after Focus-work
	    	SelectObject(hdcClient, hOldBrush); 
	    	SelectObject(hdcClient, hOldPen);
             
            // no need to delete hBrush (VB rescurce)
            DeleteObject(hPenBlack);
            DeleteObject(hPenWhite);
            DeleteObject(hPenLight);
            DeleteObject(hPenDark);
            DeleteObject(hPenGrey);
            DeleteObject(hPenMark);
            DeleteObject(hPenMarkWide);
            DeleteObject(hBrush3DLight);
            DeleteObject(hBrush3DDark);   
            DeleteObject(hBrushWhite);
            DeleteObject(hBrushBlack);
            DeleteObject(hBrushMark);
            DeleteObject(hBrushMarkBG);
            
            // Blit all of it to the screen	  
	    	BitBlt(lpdi->hDC,
				prectALL->left,
				prectALL->top,
				prectALL->right-prectALL->top,
				prectALL->bottom-prectALL->top,
				hdcClient,
				0,0,
				SRCCOPY);    
	    
	    	SelectObject(hdcClient, hOldFont);
	    	SelectObject(hdcClient, hbmpOld);
	    	DeleteObject(hbmp);
	    	DeleteDC(hdcClient); 
            
            // * * * FALL THROU * * *
            
    case ODA_FOCUS:
        if (lpdi->itemState & ODS_FOCUS && CHECKDEREF(hctl)->FocusRectOn) 
        {
            RECT    FocusRect;
            DWORD   te;
            
            pcheck = CHECKDEREF(hctl); 
            hOldFont = SelectObject(lpdi->hDC, pcheck->hfont);
            te = GetTextExtent(lpdi->hDC, VBDerefHsz(pcheck->hszCaption),
                                          CHECKDEREF(hctl)->CaptionLen);
            pcheck = CHECKDEREF(hctl);
            if (pcheck->TextBorder == BORDERNONE) 
            {
                FocusRect.left = (pcheck->Align==TEXTTORIGHT)  ? pcheck->rectText.left-2 : 
                                                                 pcheck->rectText.right-LOWORD(te)-2;
                FocusRect.right = (pcheck->Align==TEXTTORIGHT) ? FocusRect.left+LOWORD(te)+2 : 
                                                                 pcheck->rectText.right+2;
                FocusRect.top = ((pcheck->rectText.bottom - 
                                  pcheck->rectText.top)/2)-(HIWORD(te)/2)-2;
                FocusRect.bottom = FocusRect.top + HIWORD(te)+2;
            }
            else 
            {
                FocusRect.left   = pcheck->rectBox.left-1;
                FocusRect.right  = pcheck->rectBox.right+1;
                FocusRect.top    = pcheck->rectBox.top-2;
                FocusRect.bottom = pcheck->rectBox.bottom+2;
            }    
            DrawFocusRect(lpdi->hDC, &FocusRect);
        	SelectObject(lpdi->hDC, hOldFont);
        }
        break;
    }
}


//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaCheck(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the radiopicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920526AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaCheck(HCTL hctl, HWND hWnd)
{
    PCHECK  pcheck = CHECKDEREF(hctl);
    LPRECT  prectALL = &pcheck->rectDrawInto;
    LPRECT  prectText = &pcheck->rectText;
    LPRECT  prectBox = &pcheck->rectBox;
    RECT    rectALL;
    SHORT   middle;
    
    // get the clientarea
    GetClientRect(hWnd, &rectALL);
    
    // calculate the window to work in 
    prectALL->left  = rectALL.left;
    prectALL->right = rectALL.right;
    prectALL->bottom=rectALL.bottom;
    prectALL->top   = rectALL.top;
    
    if (pcheck->Align == TEXTTORIGHT) 
    {
        // calculate radiosymbol rectangle
        middle = (prectALL->bottom-prectALL->top)/2;
        prectBox->left = prectALL->left+CHECK_BOXFROMBORDER;
        prectBox->right = prectBox->left+CHECK_BOXHEIGHT;
        prectBox->top = middle-(CHECK_BOXHEIGHT/2);
        prectBox->bottom = prectBox->top+CHECK_BOXHEIGHT;
    
        // calculate text rectangle
        prectText->left = prectALL->left+CHECK_TEXTFROMBORDER;
        prectText->right = prectALL->right-4;
        prectText->bottom = prectALL->bottom;
        prectText->top = prectALL->top; 
    }
    else 
    {
        // calculate checksymbol rectangle
        middle = (prectALL->bottom-prectALL->top)/2;
        prectBox->left = prectALL->right-CHECK_BOXFROMBORDER-CHECK_BOXHEIGHT;
        prectBox->right = prectBox->left+CHECK_BOXHEIGHT;
        prectBox->top = middle-(CHECK_BOXHEIGHT/2);
        prectBox->bottom = prectBox->top+CHECK_BOXHEIGHT;
    
        // calculate text rectangle
        prectText->left = prectALL->left+4;
        prectText->right = prectALL->right-(CHECK_TEXTFROMBORDER);
        prectText->bottom = prectALL->bottom;
        prectText->top = prectALL->top;   
    }    
}    
