//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         checkbox.h
//   
// PURPOSE:      Header file for CHECKBOX subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920602AH Prehistory
//   
//****************************************************************************                    


// Misc defines for Circle
#define CHECK_BACKGROUND_DEFAULT    GREY
#define CHECK_BOXFROMBORDER         1
#define CHECK_BOXHEIGHT             12
#define CHECK_TEXTFROMCIRCLE        6
#define CHECK_TEXTFROMBORDER        (CHECK_BOXFROMBORDER+CHECK_BOXHEIGHT+CHECK_TEXTFROMCIRCLE)
#define CHECKBOX_DEFAULTWIDTH		80
#define CHECKBOX_DEFAULTHEIGHT      14
//---------------------------------------------------------------------------
// CHECK control data and structs
//---------------------------------------------------------------------------
typedef struct tagCHECK
{   
    HSZ		hszabout;
    HPIC    hpicUp;         // handle for picture up if any
    HPIC    hpicDown;       // handle for picture down if any
    HPIC    hpicDisabled;	// handle for disabled picture
    HWND    ParenthWnd;     // Handle to Parent
    RECT    rectDrawInto;   // interior to work in
    RECT    rectText;       // rectangle to display text in
    RECT    rectBox;        // radiosymbol rectangle
    RECT    rectFocus;      // rectangle for Focus
    ENUM    alignment;      // 0=Text to the right/1=Text to the left
    LONG    Light3DColor;   // light part of 3D border
    LONG    Dark3DColor;    // Dark part of 3D border
    SHORT   Look3D;         // 3D look whanted.
    HFONT   hfont;          // handle to controls font
    HSZ     hszCaption;     // handle to caption string
    SHORT   CaptionLen;     // length for Captiontext;
    ENUM    Font3D;         // if 3D font whanted
    ENUM    CheckStyle;     // Stil fr radioknapp
    BOOL    ToggleStatus;   // Status: TRUE if selected
    BOOL    FocusRectOn;    // True if Focusrectangle
    ENUM    Align;          // Text placement
    LONG    MarkFG;         // Forground Color for mark
    LONG    MarkBG;         // BackGroundColor for mark
    ENUM    TextBorder;     // Attributes for textborder
    ENUM    TextBorderAlign; // Alignement in a textbox
} CHECK;

typedef CHECK FAR * PCHECK;

#define CHECKDEREF(hctl)     ((PCHECK)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export CheckCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_CHECK_NAME            0
#define IPROP_CHECK_INDEX           1
#define IPROP_CHECK_PARENT          2
#define IPROP_CHECK_BACKCOLOR       3
#define IPROP_CHECK_LEFT            4
#define IPROP_CHECK_TOP             5
#define IPROP_CHECK_WIDTH           6
#define IPROP_CHECK_HEIGHT          7
#define IPROP_CHECK_ENABLED         8
#define IPROP_CHECK_VISIBLE         9
#define IPROP_CHECK_MOUSEPOINTER    10
#define IPROP_CHECK_CAPTION         11
#define IPROP_CHECK_FONTNAME        12
#define IPROP_CHECK_FONTSIZE        13
#define IPROP_CHECK_FONTBOLD        14
#define IPROP_CHECK_FONTITALIC      15
#define IPROP_CHECK_FONTSTRIKE      16
#define IPROP_CHECK_FONTUNDER       17
#define IPROP_CHECK_DRAG            18
#define IPROP_CHECK_DRAGICON        19
#define IPROP_CHECK_TABINDEX        20
#define IPROP_CHECK_TABSTOP         21
#define IPROP_CHECK_TAG             22
#define IPROP_CHECK_STYLE           23
#define IPROP_CHECK_FONT3D          24
#define IPROP_CHECK_DARK3DCOLOR     25
#define IPROP_CHECK_LIGHT3DCOLOR    26
#define IPROP_CHECK_FORECOLOR       27
#define IPROP_CHECK_TOGGLESTATUS    28
#define IPROP_CHECK_PICTUREUP       29
#define IPROP_CHECK_PICTUREDOWN     30
#define IPROP_CHECK_FOCUSRECTON     31
#define IPROP_CHECK_ALIGN           32
#define IPROP_CHECK_MARKFG          33
#define IPROP_CHECK_MARKBG          34
#define IPROP_CHECK_TEXTBORDER      35
#define IPROP_CHECK_TEXTBORDERALIGN 36 
#define IPROP_CHECK_ABOUT			37
#define IPROP_CHECK_HWND			38
#define IPROP_CHECK_PICTUREDISABLED 39

#ifdef CTL_DATA

PROPINFO Property_Check_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(CHECK, hszabout)
};                                 


PROPINFO propinfoCheckLight3DColor =
{
    "Light3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,Light3DColor), 0,
	WHITE
};

PROPINFO propinfoCheckDark3DColor =
{
    "Dark3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,Dark3DColor), 0,
	DARKGREY
};

PROPINFO propinfoCheckMarkFG =
{
    "MarkForeGround",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,MarkFG), 0,
	BLACK
};

PROPINFO propinfoCheckMarkBG =
{
    "MarkBackGround",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,MarkBG), 0,
	WHITE
};

// CheckBox Styles
#define CHECKNORMAL         0
#define CHECKCOMPLETE       1
#define CHECKCROSSED        2
#define CHECKCROSSEDLARGE   3
#define CHECKCHECK          4
#define CHECKPICTURE        5
#define CHECKPICTURELARGE   6

PROPINFO propinfoCheckStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,CheckStyle), 0,
    CHECKNORMAL,
    "0 - Normal.\0"
    "1 - Complete fill.\0"
    "2 - Crossed.\0"
    "3 - Crossed Large.\0"
    "4 - Check.\0"
    "5 - Small Picture.\0"
    "6 - Large Picture.\0",
    CHECKPICTURELARGE
};

PROPINFO propinfoCheckFont3D =
{
    "Font3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,Font3D), 0,
    FONT3DNORMAL,
    "0 - Normal Text.\0"
    "1 - Carved light.\0"
    "2 - Carved Heavy.\0"
    "3 - Raised light.\0"
    "4 - Raised Heavy.\0",
    FONT3DRAISEDHEAVY
};

PROPINFO propinfoCheckToggleStatus =
{
    "Value",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,ToggleStatus), 0,
	FALSE
};


PROPINFO propinfoCheckPictureUp =
{
    "PictureUp",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(CHECK,hpicUp), 0,
	0
};

PROPINFO propinfoCheckPictureDown =
{
    "PictureDown",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(CHECK,hpicDown), 0,
	0
};
    
PROPINFO propinfoCheckPictureDisabled =
{
    "PictureDisabled",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(CHECK,hpicDisabled), 0,
	0
};

PROPINFO propinfoCheckFocusRectOn =
{
    "FocusRectOn",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,FocusRectOn), 0,
	TRUE
};

#define TEXTTORIGHT         0
#define TEXTTOLEFT          1

PROPINFO propinfoCheckAlign =
{
    "Alignment",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,Align), 0,
    TEXTTORIGHT,
    "0 - Text to the Right.\0"
    "1 - Text to the Left.\0",
    TEXTTOLEFT
};
      
#define BORDERNONE          0
#define BORDERFRAME         1
#define BORDER3DCARVED      2
#define BORDER3DRAISED      3  

PROPINFO propinfoCheckTextBorder =
{
    "TextBorder",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(CHECK,TextBorder), 0,
    BORDERNONE,
    "0 - No border around text.\0"
    "1 - Border around text.\0"
    "2 - 3D Carved border around text.\0"
    "4 - 3D Raised border around text.\0",
    BORDER3DRAISED
};

PROPINFO propinfoCheckTextBorderAlign =
{
    "TextBorderAlign",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(CHECK,TextBorderAlign), 0,
    HALIGNCENTER,
    "0 - Left.\0"
    "1 - Center.\0"
    "2 - Right.\0",
    HALIGNRIGHT
};

PROPINFO propinfoCheckhWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};


PPROPINFO proplistCheck[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    &propinfoCheckStyle,
    &propinfoCheckFont3D,
    &propinfoCheckDark3DColor,
    &propinfoCheckLight3DColor,
    PPROPINFO_STD_FORECOLOR,
    &propinfoCheckToggleStatus,
    &propinfoCheckPictureUp,
    &propinfoCheckPictureDown,
    &propinfoCheckFocusRectOn,
    &propinfoCheckAlign,
    &propinfoCheckMarkFG,
    &propinfoCheckMarkBG,
    &propinfoCheckTextBorder,
    &propinfoCheckTextBorderAlign,
    &Property_Check_About,
    &propinfoCheckhWnd,
    &propinfoCheckPictureDisabled,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_CHECK_CLICK       0
#define EVENT_CHECK_DBLCLICK    1
#define EVENT_CHECK_DRAGDROP    2
#define EVENT_CHECK_DRAGOVER    3
#define EVENT_CHECK_GOTFOCUS    4
#define EVENT_CHECK_KEYDOWN     5
#define EVENT_CHECK_KEYPRESS    6
#define EVENT_CHECK_KEYUP       7
#define EVENT_CHECK_LOSTFOCUS   8

#ifdef CTL_DATA
PEVENTINFO eventlistCheck[] =
{
    PEVENTINFO_STD_CLICK,
    PEVENTINFO_STD_DBLCLICK,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    PEVENTINFO_STD_GOTFOCUS,
    PEVENTINFO_STD_KEYDOWN,
    PEVENTINFO_STD_KEYPRESS,
    PEVENTINFO_STD_KEYUP,
    PEVENTINFO_STD_LOSTFOCUS,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelCheck =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fMnemonic, // MODEL flags
    (PCTLPROC)CheckCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    BS_AUTOCHECKBOX | BS_OWNERDRAW,  // Default Window style
    sizeof(CHECK),              // cbCtlExtra for CHECK structure
    IDBMP_CHECK,                // Palette bitmap ID
    "EsCheck",		       		// Default control name
    "EsCheck",		       		// Visual Basic class name
    "Button",                   // Parent class name
    proplistCheck,              // Properties list
    eventlistCheck,             // Events list
	IPROP_CHECK_CAPTION,		// Default property
	EVENT_CHECK_CLICK,			// Default event
	IPROP_CHECK_TOGGLESTATUS,	// Standard property
}; 
#endif  // CTL_DATA   
   
LPMODEL modellistCheck[] =
    {
    &modelCheck,
    NULL
    };

MODELINFO modelinfoCheck =
    {
    VB_VERSION, 			// VB version being used
    modellistCheck			// MODEL list
    };


#endif  // RC_INVOKED

//---------------------------------------------------------------------------
